
package java.lang;

import java.io.*;

// Referenced classes of package java.lang:
//			Object, Integer, String, StringBuffer, 
//			System

/**
 *
 * @author Bruce
 */

public class Throwable
{

    private Throwable cause;
	private String detailMessage;
	private String backtrace[];

    /*
     * public Throwable()
     *
     * Constructs a new throwable with null as its detail message. The cause is not initialized,
     *  and may subsequently be initialized by a call to initCause(java.lang.Throwable).
     *
     *  This initializes the stack trace data in the newly created throwable.
     */

    /**
     * Throwable
     */
	public Throwable()
	{}

    /*
     * public Throwable(String message)
     *
     * Constructs a new throwable with the specified detail message. The cause is not initialized,
     *  and may subsequently be initialized by a call to initCause(java.lang.Throwable).
     *
     *  This initializes the stack trace data in the newly created throwable.
     *
     * Parameters:
     *
     *      message - the detail message. The detail message is saved for later retrieval by the getMessage() method.
     */

    /**
     *
     * @param s ?
     */
    
	public Throwable(String s)
	{}

    /*
     * public Throwable(Throwable cause)
     *
     * Constructs a new throwable with the specified cause and a detail message of
     *  (cause==null ? null : cause.toString()) (which typically contains the class and detail message of cause).
     *  This constructor is useful for throwables that are little more than wrappers for other throwables
     *  (for example, PrivilegedActionException).
     *
     *  This initializes the stack trace data in the newly created throwable.
     *
     * Parameters:
     *
     *      cause - the cause (which is saved for later retrieval by the getCause() method). (A null value
     *              is permitted, and indicates that the cause is nonexistent or unknown.)
     */

    /**
     *
     * @param c ?
     */
    
    public Throwable(Throwable c)
    {}

    /*
     * public Throwable(String message, Throwable cause)
     *
     * Constructs a new throwable with the specified detail message and cause.
     *
     * Note that the detail message associated with cause is not automatically incorporated in this
     *  throwable's detail message.
     *
     *  This initializes the stack trace data in the newly created throwable.
     *
     * Parameters:
     *
     *      message - the detail message (which is saved for later retrieval by the getMessage() method).
     *
     *      cause - the cause (which is saved for later retrieval by the getCause() method). (A null value is
     *              permitted, and indicates that the cause is nonexistent or unknown.)
     */

    /**
     *
     * @param s ?
     * @param c ?
     */
    
    public Throwable(String s, Throwable c)
    {}

    /*
     * public Throwable initCause(Throwable cause)
     *
     * Initializes the cause of this throwable to the specified value. (The cause is the throwable that caused this
     *  throwable to get thrown.)
     *
     * This method can be called at most once. It is generally called from within the constructor, or immediately
     *  after creating the throwable. If this throwable was created with Throwable(Throwable) or
     *  Throwable(String,Throwable), this method cannot be called even once.
     *
     * Parameters:
     *
     *      cause - the cause (which is saved for later retrieval by the getCause() method). (A null value is
     *              permitted, and indicates that the cause is nonexistent or unknown.)
     *
     * Returns:
     *
     *      a reference to this Throwable instance.
     *
     * Throws:
     *
     *      IllegalArgumentException - if cause is this throwable. (A throwable cannot be its own cause.)
     *
     *      IllegalStateException - if this throwable was created with Throwable(Throwable) or
     *                              Throwable(String, Throwable), or this method has already been called on this throwable.
     */

    /**
     *
     * @param c ?
     * @return ?
     */
    
    public Throwable initCause(Throwable c)
    {}

    /*
     * public Throwable getCause()
     *
     * Returns the cause of this throwable or null if the cause is nonexistent or unknown. (The cause is the throwable
     *  that caused this throwable to get thrown.)
     *
     * This implementation returns the cause that was supplied via one of the constructors requiring a Throwable, or
     *  that was set after creation with the initCause(Throwable) method. While it is typically unnecessary to override
     *  this method, a subclass can override it to return a cause set by some other means. This is appropriate
     *  for a "legacy chained throwable" that predates the addition of chained exceptions to Throwable. Note that
     *  it is not necessary to override any of the PrintStackTrace methods, all of which invoke the getCause method to
     *  determine the cause of a throwable.
     *
     * Returns:
     *
     *      the cause of this throwable or null if the cause is nonexistent or unknown.
     */

    /**
     *
     * @return ?
     */
    
    public Throwable getCause()
    {}

    /*
     * public Throwable fillInStackTrace()
     *
     * Normally fills in the execution stack trace however this is done when the Throwable is instantiated. This
     *  insures that the trace contains pertinent information. So this is a dummy method essentially.
     *
     * Returns:
     *
     *      a reference to this Throwable instance.
     */

    /**
     *
     * @return ?
     */
    
    public Throwable fillInStackTrace()
    {}

    /*
     * public String[] getStackTrace()
     *
     * Provides programmatic access to the stack trace information printed by printStackTrace(). Returns an array of
     *  stack trace strings, each representing one stack frame. The zeroth element of the array (assuming the array's
     *  length is non-zero) represents the top of the stack, which is the last method invocation in the sequence.
     *  Typically, this is the point at which this throwable was created and thrown. The last element of the
     *  array (assuming the array's length is non-zero) represents the bottom of the stack, which is the first method
     *  invocation in the sequence.
     *
     * Returns:
     *
     *      an array of stack trace strings representing the stack trace pertaining to this throwable.
     */

    /**
     *
     * @return ?
     */
    
    public static native String[] getStackTrace();

    /*
     * public void setStackTrace(String[] stackTrace)
     *
     * Sets the stack trace strings that will be returned by getStackTrace() and printed by printStackTrace() and
     *  related methods. This method, which is designed for use by RPC frameworks and other advanced systems, allows
     *  the client to override the default stack trace that is either generated by fillInStackTrace() when a throwable
     *  is constructed or deserialized when a throwable is read from a serialization stream.
     *
     * If the stack trace of this Throwable is not writable, calling this method has no effect other than
     *  validating its argument.
     *
     * Parameters:
     *
     *      stackTrace - the stack trace elements to be associated with this Throwable. The specified array is copied
     *                   by this call; changes in the specified array after the method invocation returns will have
     *                   no affect on this Throwable's stack trace.
     *
     * Throws:
     *
     *      NullPointerException - if stackTrace is null or if any of the elements of stackTrace are null
     */

    /**
     *
     * @param stackTrace ?
     */
    
    public void setStackTrace(String[] stackTrace)
    {}

    /*
     * public String getLocalizedMessage()
     *
     * Creates a localized description of this throwable. Subclasses may override this method in order to produce a
     *  locale-specific message. For subclasses that do not override this method, the default implementation returns
     *  the same result as getMessage().
     *
     * Returns:
     *
     *      The localized description of this throwable.
     */

    /**
     *
     * @return ?
     */
    
	public String getLocalizedMessage()
	{}

    /*
     * public String getMessage()
     *
     * Returns the detail message string of this throwable.
     *
     * Returns:
     *
     *      the detail message string of this Throwable instance (which may be null).
     */

    /**
     *
     * @return ?
     */
    
	public String getMessage()
	{}

    /**
     * printStackTrace
     */
    public void printStackTrace()
	{}

    /**
     *
     * @param printstream ?
     */
    public void printStackTrace(PrintStream printstream)
	{}

    /**
     *
     * @param printwriter ?
     */
    public void printStackTrace(PrintWriter printwriter)
	{}

	public String toString()
	{}

    private native String getClassNameNative();

}
