
package java.util;

import com.integpg.system.Timebase;

/**
 *
 * @author Bruce
 */
public abstract class TimeZone
	implements Cloneable
{
	private String ID;
	private static TimeZone defaultTimeZone;

    /**
     * Timezone object constructor.
     */
    public TimeZone() {}

    /**
     * Creates a copy of this TimeZone.
     * 
     * @return clone of this object
     * @throws CloneNotSupportedException if not supported
     */
	public Object clone() throws CloneNotSupportedException {}

    /**
     * Gets all the available IDs supported.
     * 
     * @return array of identifiers
     */
    public static String[] getAvailableIDs() {}
    private static native String[] tz_getAvailableIDs();

    /**
     * Gets the available IDs according to the given time zone offset in milliseconds.
     * 
     * @param offset the offset from UTC
     * @return an array of identifiers, where the time zone for that ID has the specified UTC offset.
     */
    public static String[] getAvailableIDs(int offset)
	{}
    private static native String[] tz_getOffsetIDs(int minutes);

    /**
     * Gets the default TimeZone for this JNIOR.
     * 
     * @return the default TimeZone
     */
    public static synchronized TimeZone getDefault() {